/***********************************************************************
*
*  FILE        : tb_rx65n_main.cpp
*  DATE        : 2019-02-26
*  DESCRIPTION : Main Program
*
*  NOTE:THIS IS A TYPICAL EXAMPLE.
*
***********************************************************************/
#include "RenesasRX.h"
#include "tbrx65ndef.h"
#include "stdio.h"
#include "string.h"

extern volatile st_dtc_data_t dtc_transferdata_vector39;

volatile bool SCI6_tend;
volatile bool RSPI0_rend;
volatile int32_t RSPI0_txint_count;
volatile int32_t RSPI0_dtce_chk_0;
volatile int32_t RSPI0_dtce_chk[10];
volatile int32_t RSPI0_dtc_cra_chk_0;
volatile int32_t RSPI0_dtc_cra_chk[10];

#define RSPI0_DATA_LEN 3
uint32_t RSPI0_send_buff[RSPI0_DATA_LEN] = { 'A', 'B', 'C' };
uint32_t RSPI0_recv_buff[RSPI0_DATA_LEN] = { '-', '-', '-' };

uint8_t SCI6_send_buff[200];

int main(void)
{
    LED0 = LED_OFF;
    LED1 = LED_OFF;

    R_Config_DTC_Start();
    R_Config_RSPI0_Start();

    RSPI0_rend = false;
    RSPI0_txint_count = 0;
    RSPI0_dtce_chk_0 = ICU.DTCER[39].BIT.DTCE;
    RSPI0_dtc_cra_chk_0 = (dtc_transferdata_vector39.cra_crb >> 16);

    R_Config_RSPI0_Send_Receive( RSPI0_send_buff, RSPI0_DATA_LEN, RSPI0_recv_buff );

    while ( RSPI0_rend == false );

    R_Config_SCI6_Start();

    sprintf( (char *)SCI6_send_buff, "Loopback = %c%c%c --> %c%c%c\r\nRSPI+DTC TXINT count = %d\r\nDTCE = %d(init), %d(1st INT), %d(2nd INT)\r\nCRA  = %d(init), %d(1st INT), %d(2nd INT)\r\n", 
    RSPI0_send_buff[0], RSPI0_send_buff[1], RSPI0_send_buff[2], 
    RSPI0_recv_buff[0], RSPI0_recv_buff[1], RSPI0_recv_buff[2], 
    RSPI0_txint_count, 
    RSPI0_dtce_chk_0, RSPI0_dtce_chk[0], RSPI0_dtce_chk[1],
    RSPI0_dtc_cra_chk_0, RSPI0_dtc_cra_chk[0], RSPI0_dtc_cra_chk[1] );

    SCI6_tend = false;

    R_Config_SCI6_Serial_Send( SCI6_send_buff, strlen( (char *)SCI6_send_buff ) );

    while ( SCI6_tend == false );

    while (1)
    {
        ;
    }
}
